EDIT - bug #9672

NPE when CDMPreference contains allowOverride=NULL
06/16/2021 08:35 AM - Katja Luther

Status: Duplicate Start date:

Priority: New Due date:

Assignee: Andreas Kohlbecker % Done: 0%
Category: data Estimated time: 0:00 hour
Target version: Release 5.25

Severity: normal Found in Version:

Description

eu.etaxonomy.cdm.api.service.MediaServicelmpl.readResourceMetadataFiltered(MediaRepresentation representation) throws
IOException, HttpException

bei
key_subject key_predicate value allowQverride
/ media.metadataKeyword.iclud [title,artist,rights,location,copyri | NULL

es ght,date,photographer,locality,t
axon,collection,description,Sou
rce,https,ID,CC licence

gibt der IlIF Service nichts zuriick, habe aber auch nicht im Log geschaut. Das kann nur ein NPE sein.
Interner Nachtrag:

Wenn man in den CdmPreferences fir allowOverride NULL eingibt, passiert irgendwo eine NPE. Das sollen wir und mal ansehen.
Stacktrace habe ich keinen.

Related issues:
Related to EDIT - task #9673: Remove allowNull from allowOverride New

History

#1 - 06/16/2021 08:36 AM - Katja Luther
- Category set to cdmlib

- Assignee set to Katja Luther

#2 - 06/16/2021 10:08 AM - Andreas Kohlbecker

- Description updated

#3 - 06/16/2021 10:16 AM - Andreas Kohlbecker
- Tags set to fast
- Assignee changed from Katja Luther to Andreas Mdiller

- Target version changed from Unassigned CDM tickets to Release 5.25

Hier ist der Stacktrace:

Caused by: java.lang.IllegalArgumentException: Can not set boolean field eu.etaxonomy.cdm.model.metadata.CdmPr
eference.allowOverride to null value
at sun.reflect.UnsafeFieldAccessorImpl.throwSetIllegalArgumentException (UnsafeFieldAccessorImpl. java:167)
at sun.reflect.UnsafeFieldAccessorImpl.throwSetIllegalArgumentException (UnsafeFieldAccessorImpl.java:171)
at sun.reflect.UnsafeBooleanFieldAccessorImpl.set (UnsafeBooleanFieldAccessorImpl. java:80)
at java.lang.reflect.Field.set (Field. java:764)
at org.hibernate.property.access.spi.SetterFieldImpl.set (SetterFieldImpl. java:38)
at org.hibernate.tuple.entity.AbstractEntityTuplizer.setPropertyValues (AbstractEntityTuplizer.java:713)
at org.hibernate.tuple.entity.PojoEntityTuplizer.setPropertyValues (PojoEntityTuplizer.java:207)
at org.hibernate.persister.entity.AbstractEntityPersister.setPropertyValues (AbstractEntityPersister. java:4
706)
at
at
at

org.hibernate.engine.internal.TwoPhaseLoad.doInitializeEntity (TwoPhaseLoad. java:183)
org.hibernate.engine.internal.TwoPhaselLoad.initializeEntity (TwoPhaseLoad. java:125)
org.hibernate.loader.plan.exec.process.internal.AbstractRowReader.performTwoPhaseLoad (AbstractRowReader

.java:238)

at
at

org.hibernate.loader.plan.exec.process.internal.AbstractRowReader.finishUp (AbstractRowReader. java:209)
org.hibernate.loader.plan.exec.process.internal.ResultSetProcessorImpl.extractResults (ResultSetProcesso

rImpl. java:133)

at

org.hibernate.loader.plan.exec.internal.AbstractLoadPlanBasedLoader.executeLoad (AbstractLoadPlanBasedLo

ader.java:122)

at

org.hibernate.loader.plan.exec.internal.AbstractLoadPlanBasedLoader.executelLoad (AbstractLoadPlanBasedLo

ader.java:86)

at

org.hibernate.loader.entity.plan.AbstractLoadPlanBasedEntityLoader.load (AbstractLoadPlanBasedEntityLoad

er.java:167)

at
at
508)
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at

org.hibernate.persister.entity.AbstractEntityPersister.load (AbstractEntityPersister.java:4083)
org.hibernate.event.internal.DefaultLoadEventListener.loadFromDatasource (DefaultLoadEventListener. java:

org.hibernate.event.internal.DefaultLoadEventListener.doLoad (DefaultLoadEventListener. java:478)
org.hibernate.event.internal.DefaultLoadEventListener.load (DefaultLoadEventListener. java:219)
org.hibernate.event.internal.DefaultLoadEventListener.proxyOrLoad (DefaultLoadEventListener. java:262)
org.hibernate.event.internal.DefaultLoadEventListener.doOnLoad (DefaultLoadEventListener.java:121)
org.hibernate.event.internal.DefaultLoadEventListener.onLoad (DefaultLoadEventListener. java:89)
org.hibernate.internal.SessionImpl.fireLoad(SessionImpl.java:1142)
org.hibernate.internal.SessionImpl.access$2600 (SessionImpl.java:167)
org.hibernate.internal.SessionImpl$IdentifierLoadAccessImpl.doLoad(SessionImpl. java:2762)
org.hibernate.internal.SessionImpl$IdentifierLoadAccessImpl.load(SessionImpl. java:2741)
org.hibernate.internal.SessionImpl.get (SessionImpl. java:978)
eu.etaxonomy.cdm.persistence.dao.hibernate.common.PreferenceDaoImpl.get (PreferenceDaoImpl. java:41)
eu.etaxonomy.cdm.api.service.PreferenceServiceImpl.lambda$0 (PreferenceServicelmpl. java:186)
java.util.concurrent.ConcurrentHashMap.computeIfAbsent (ConcurrentHashMap.java:1660)
eu.etaxonomy.cdm.api.service.PreferenceServiceImpl.fromCacheGet (PreferenceServiceImpl. java:186)
eu.etaxonomy.cdm.api.service.PreferenceServiceImpl.findExact (PreferenceServiceImpl. java:58)
sun.reflect.GeneratedMethodAccessor633.invoke (Unknown Source)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:333)
org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMethodInvocation

.java:190)

at
7)
at

org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15

org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (TransactionI

nterceptor. java:99)

at

org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Transactio

nAspectSupport. java:283)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterceptor. java:9
6)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17
9)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)

at com.sun.proxy.S$Proxyl98.findExact (Unknown Source)

at eu.etaxonomy.cdm.api.service.MediaServiceImpl.mediaMetadataKeyIncludes (MediaServiceImpl. java:345)

at eu.etaxonomy.cdm.api.service.MediaServicelImpl.readResourceMetadataFiltered (MediaServiceImpl. java:293)

at sun.reflect.GeneratedMethodAccessor690.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:333)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokedJoinpoint (ReflectiveMethodInvocation
.Java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15
7)

at

org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (TransactionI

nterceptor. java:99)

at

org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Transactio

nAspectSupport. java:283)

at
6)
at
9)
at
at
at
at
at
at
at
at

org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterceptor.java:9
org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17

org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)
com.sun.proxy.$Proxyl99.readResourceMetadataFiltered (Unknown Source)
eu.etaxonomy.cdm.remote.controller.iiif.ManifestComposer.createCanvas (ManifestComposer. java:246)
eu.etaxonomy.cdm.remote.controller.iiif.ManifestComposer.lambda$0 (ManifestComposer.java:148)
java.util.stream.ReferencePipeline$3$1.accept (ReferencePipeline. java:193)
Java.util.ArrayListS$ArrayListSpliterator.forEachRemaining (ArrayList.java:1374)
java.util.stream.AbstractPipeline.copyInto (AbstractPipeline.java:481)

java.util.stream.AbstractPipeline.wrapAndCopyInto (AbstractPipeline. java:471)
at java.util.stream.ReduceOps$ReduceTask.doLeaf (ReduceOps. java:747)

at java.util.stream.ReduceOps$ReduceTask.doLeaf (ReduceOps. java:721)

at java.util.stream.AbstractTask.compute (AbstractTask.java:316)

at Jjava.util.concurrent.CountedCompleter.exec (CountedCompleter. java:731)
at java.util.concurrent.ForkJoinTask.doExec (ForkJoinTask. java:289)

at java.util.concurrent.ForkJoinTask.doInvoke (ForkJoinTask. java:401)

at java.util.concurrent.ForkJoinTask.invoke (ForkJoinTask. java:734)

at java.util.stream.ReduceOps$ReduceOp.evaluateParallel (ReduceOps. java:714)

at java.util.stream.AbstractPipeline.evaluate (AbstractPipeline. java:233)

at java.util.stream.ReferencePipeline.collect (ReferencePipeline. java:499)

at eu.etaxonomy.cdm.remote.controller.iiif.ManifestComposer.manifestFor (ManifestComposer.java:155)
81 more

Entweder muss das Datenbankfeld ein NOT NULL contraint bekommen oder CdmPreference.allowOverride muss Boolean statt boolean sein.

Damit fallt das in deinen Bereich Andreas,

#4 - 06/16/2021 10:17 AM - Andreas Kohlbecker

- Subject changed from NPE in MediaServicelmpl.readResourceMetadataFiltered when CDMPreference contains allowOverride=true to NPE in
MediaServicelmpl.readResourceMetadataFiltered when CDMPreference contains allowOverride=NULL

#5 - 06/16/2021 10:17 AM - Andreas Kohlbecker

- Subject changed from NPE in MediaServicelmpl.readResourceMetadataFiltered when CDMPreference contains allowOverride=NULL to NPE when
CDMPreference contains allowOverride=NULL

#6 - 06/16/2021 10:48 AM - Andreas Miiller
- Category changed from cdmlib to data
- Status changed from New to In Progress

- Assignee changed from Andreas Miiller to Andreas Kohlbecker

Allow override must never be NULL (even if the schema for historical reasons allwos null). Please adapt data in your database.

#7 - 06/16/2021 10:51 AM - Andreas Miiller
- Related to task #9673: Remove allowNull from allowOverride added

#8 - 06/16/2021 10:52 AM - Andreas Miiller

| added a ticket which should try to set the allowOverride to allowNull=false if possible (unfortunately not trival via update script): #9673

#9 - 06/16/2021 10:53 AM - Andreas Miiller

Is this ticket really only about "allowOverride=NULL"? | ask because there is so much additional information in the description which is not related to
this data error.

#10 - 06/16/2021 10:56 AM - Katja Luther

Andreas Muller wrote:

Is this ticket really only about "allowOverride=NULL"? | ask because there is so much additional information in the description which is not
related to this data error.

when | created the ticket | did not know that the ticket was only about the NULL value for allowOverride therefore | added the whole mail conversation,
but now we can reduce it.

#11 - 07/09/2021 10:32 AM - Andreas Miuiller

- Status changed from In Progress to Feedback

| think this ticket can be closed (after reducing the description), as the only open issue is handled in #9673

#12 - 07/15/2021 08:00 AM - Andreas Kohlbecker
- Description updated

- Status changed from Feedback to Duplicate

closing as duplicate of #9673
#13 - 07/15/2021 06:30 PM - Andreas Kohlbecker
- Tags deleted (fast)
